package main

/*
#include <stdbool.h>
#include <stdint.h>

typedef struct Card {
    uint32_t card_number;
} Card;

typedef struct TimeProfile {
    uint32_t ID;
} TimeProfile;

*/
import "C"

func main() {}

//export GetCard
func GetCard(card *C.struct_Card, deviceID uint32, cardNumber uint32) *C.char {
	if err := getCard(card, deviceID, cardNumber); err != nil {
		return C.CString(err.Error())
	}

	return nil
}

// NTS: for some bizarre reason cgo will not compile if getTimeProfile is in time_profiles.go
//      and takes a *C.struct_TimeProfile argument. Compiles just fine if getTimeProfile is
//      in main.go or cards.go or if the translation between the Go struct and the C struct
//      is done in main::GetTimeProfile.
//
//      Ref. https://go-review.googlesource.com/c/go/+/277432/2/doc/go1.15.html (?)

//export GetTimeProfile
func GetTimeProfile(profile *C.struct_TimeProfile, deviceID uint32, profileID uint32) *C.char {
	if err := getTimeProfile(profile, deviceID, profileID); err != nil {
		return C.CString(err.Error())
	}

	return nil
}
